<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>

    <script src="../lib/GrobGrid.js"></script>

  </head>
  <body>

    <script>

    suite ('->constructor', () => {

        test('should thow an error if some positions are negative', () => {
            assert.throws(() => new GrobGrid([1, -2, 3]))
        })

    })

    suite ('->convert', () => {

        setup (() => {
            this.first = 10;
            this.last = 60;
            this.defaultPos = 30;
            this.excessPos = 40;
            this.shuffle = (array) => {
                for (let i = array.length - 1; i > 0; i--) {
                    const j = Math.floor(Math.random() * (i + 1));
                    [array[i], array[j]] = [array[j], array[i]];
                }
                return array;
            };
            this.duplicate = (array) => {
                let j = 0;
                let ret = [];
                for (let i = 0; i < array.length; i++) {
                    ret[j++] = array[i];
                    const tries = Math.floor(Math.random() * 3);
                    for (let k = 0; k < tries; k++) {
                        ret[j++] = array[i];
                    }
                }
                return ret;
            }
            this.positions = [this.first, 20, this.defaultPos, this.excessPos, 50, this.last];
            this.nullGrid = new GrobGrid();
            this.emptyGrid = new GrobGrid([]);
            this.oneElementGrid = new GrobGrid([this.defaultPos]);
            this.twoElementsGrid = new GrobGrid(this.shuffle([this.first, this.last]));
            this.grid = new GrobGrid(this.shuffle(this.duplicate(this.positions)));
        })

        test('should return identity if null positions array is provided', () => {
            assert.equal(this.defaultPos, this.nullGrid.convert(this.defaultPos))
        })

        test('should return identity if empty positions array is provided', () => {
            assert.equal(this.defaultPos, this.emptyGrid.convert(this.defaultPos))
        })

        test('should return identity only one position is provided', () => {
            assert.equal(this.defaultPos, this.oneElementGrid.convert(this.defaultPos))
        })

        test('should return first pos if x equal to it (only 2 pos)', () => {
            assert.equal(this.first, this.twoElementsGrid.convert(this.first));
        })

        test('should return last pos if x equal to it (only 2 pos)', () => {
            assert.equal(last, this.twoElementsGrid.convert(this.last));
        })

        test('should return first pos if x equal to it', () => {
            assert.equal(this.first, this.grid.convert(this.first));
        })

        test('should return last pos if x equal to it', () => {
            assert.equal(last, this.grid.convert(this.last));
        })

        test('should return identity if x exists in positions', () => {
            assert.equal(this.defaultPos, this.grid.convert(this.defaultPos));
        })

        test('should return the closest pos to x by default', () => {
            assert.equal(this.defaultPos, this.grid.convert(this.defaultPos + 2));
        })

        test('should return first pos which is the closest pos to x by default', () => {
            assert.equal(this.first, this.grid.convert(this.first + 2));
        })

        test('should return the closest pos to x by excess', () => {
            assert.equal(this.excessPos, this.grid.convert(this.defaultPos + 8));
        })

        test('should return last pos which is the closest pos to x by excess', () => {
            assert.equal(this.last, this.grid.convert(this.last - 2));
        })

        test('should return the closest pos to x by default if it is at the middle of two consecutive positions', () => {
            assert.equal(this.defaultPos, this.grid.convert(this.defaultPos + 5));
        })

        test('should return first pos which is the closest pos to x by default if it is at the middle of to consecutive positions', () => {
            assert.equal(this.first, this.grid.convert(this.first + 5));
        })

        test('should return last pos if x is greater than it', () => {
            assert.equal(this.last, this.grid.convert(this.last + 100));
        })

        test('should return first pos if x is lower than it', () => {
            assert.equal(this.first, this.grid.convert(this.first - 10));
        })

    })

    </script>

  </body>
</html>
